'
' Use the Real Random routines to create a random bit
' Display many bits on the serial terminal
'
' Uses AN0 as the ADC channel for the random bit generator
'
' Author Les Johnson 02-02-2012 
'
' You are free to use this code as you see fit, however, a mention of the author and compiler would be appreciated.
' The code is offered as-is and Crownhill nor the author take any responsibility for its use.
'
    Include "Amicus18.inc"                  ' Configure for the Amicus18 device (18F25K20) running at 64MHz
    Include "Amicus18_ADC.inc"              ' Load the Amicus18 ADC routines into the program

$define Random_ADC_Channel 1                ' Use AN0 as the random bit generator ADC channel 
    Include "Real_Random.inc"               ' Load the Real Random macros into the program

    Dim tRand As Bit
    Dim Ypos As Byte
    Dim Xpos As Byte
    Dim bTemp As Byte

'------------------------------------------------------------------------------------------------
' Display random bits on the serial terminal as character O or a space
'
Main:
    While 1 = 1                                 ' Create an infinite loop
        For Ypos = 0 To 31                      ' Create a loop for the Y axis
            For Xpos = 0 To 63                  ' Create a loop for the X axis
                tRand = Random_GetBit()         ' Create a random bit
                If tRand = 1 Then               ' Is tRand holding 1?
                    HRSOut "O"                  ' Yes. So display an O character
                Else                            ' Otherwise...
                    HRSOut " "                  ' Display a blank space
                EndIf
            Next                                ' Close the X axis loop
            HRSOut 13                           ' Terminate the line
        Next                                    ' Close the Y axis loop
        bTemp = Random_GetByte()                ' Create a random byte
        DelayMS bTemp                           ' Delay a random number of milliseconds
        HRSOut 1                                ' Clear the serial terminal
    Wend

