'
' Use an ADC channel to create a random bit, then use this bit to build random bytes or words
' Display Dice faces on the serial terminal
'
' Author Les Johnson 02-02-2012 
'
' You are free to use this code as you see fit, however, a mention of the author and compiler would be appreciated.
' The code is offered as-is and Crownhill nor the author take any responsibility for its use.
' 
    Include "Amicus18.inc"                  ' Configure for the Amicus18 device (18F25K20) running at 64MHz
    Include "Amicus18_ADC.inc"              ' Load the Amicus18 ADC routines into the program

$define Random_ADC_Channel 1                ' Use AN0 as the random bit generator ADC channel
    Include "Real_Random.inc"               ' Load the Real Random macros into the program

    Dim wRandomResult As Word
    Dim bRandomResult As wRandomResult.Byte0
    Dim bFoundSix As Byte
    Dim bFoundFive As Byte
    Dim bFoundFour As Byte
    Dim bFoundThree As Byte
    Dim bFoundTwo As Byte
    Dim bFoundOne As Byte

'------------------------------------------------------------------------------------------------
' The main program loop starts here
' Create the faces of a dice on the serial terminal
' and show how many times a number is chosen
'
Main:
    Clear
    While 1 = 1                             ' Create an infinite loop
        HRSOut 1                            ' Clear the serial terminal
TryAgain:
        Random_Get(7, bRandomResult)        ' Create a random value between 0 and 6
        Select bRandomResult                ' Check the value of the random number
            Case 6
                HRSOut "-----------\r"
                HRSOut "| O     O |\r"
                HRSOut "|         |\r"
                HRSOut "| O     O |\r"
                HRSOut "|         |\r"
                HRSOut "| O     O |\r"
                HRSOut "-----------\r"
                Inc bFoundSix
            Case 5
                HRSOut "-----------\r"
                HRSOut "| O     O |\r"
                HRSOut "|         |\r"
                HRSOut "|    O    |\r"
                HRSOut "|         |\r"
                HRSOut "| O     O |\r"
                HRSOut "-----------\r"
                Inc bFoundFive
            Case 4
                HRSOut "-----------\r"
                HRSOut "| O     O |\r"
                HRSOut "|         |\r"
                HRSOut "|         |\r"
                HRSOut "|         |\r"
                HRSOut "| O     O |\r"
                HRSOut "-----------\r"
                Inc bFoundFour
            Case 3
                HRSOut "-----------\r"
                HRSOut "| O       |\r"
                HRSOut "|         |\r"
                HRSOut "|    O    |\r"
                HRSOut "|         |\r"
                HRSOut "|       O |\r"
                HRSOut "-----------\r"
                Inc bFoundThree
            Case 2
                HRSOut "-----------\r"
                HRSOut "|       O |\r"
                HRSOut "|         |\r"
                HRSOut "|         |\r"
                HRSOut "|         |\r"
                HRSOut "| O       |\r"
                HRSOut "-----------\r"
                Inc bFoundTwo
            Case 1
                HRSOut "-----------\r"
                HRSOut "|         |\r"
                HRSOut "|         |\r"
                HRSOut "|    O    |\r"
                HRSOut "|         |\r"
                HRSOut "|         |\r"
                HRSOut "-----------\r"
                Inc bFoundOne
            Case Else
                GoTo TryAgain
        EndSelect
        '
        ' Display how many times a number is chosen
        '
        HRSOut "Amount of times found\r"
        HRSOut "6: (", Dec3 bFoundSix, ") ", Rep "*"\bFoundSix, 13
        HRSOut "5: (", Dec3 bFoundFive, ") ", Rep "*"\bFoundFive, 13
        HRSOut "4: (", Dec3 bFoundFour, ") ", Rep "*"\bFoundFour, 13
        HRSOut "3: (", Dec3 bFoundThree, ") ", Rep "*"\bFoundThree, 13
        HRSOut "2: (", Dec3 bFoundTwo, ") ", Rep "*"\bFoundTwo, 13
        HRSOut "1: (", Dec3 bFoundOne, ") ", Rep "*"\bFoundOne, 13

        DelayMS 500                         ' Delay for 500 milliseconds
        Random_Get(500, wRandomResult)      ' Get a random value between 0 and 499
        DelayMS wRandomResult               ' Delay by the random number of milliseconds
    Wend


